<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>Peaks of North America</title>
	<meta name="generator" content="TextMate http://macromates.com/">
	<meta name="author" content="Ryan Stewart">
	<!-- Date: 2010-11-08 -->
	<link rel="stylesheet" href="style.css" type="text/css" media="screen" charset="utf-8"/>
	<script src="jquery-1.4.3.min.js" type="text/javascript" charset="utf-8"></script>
	<script src="pagination.js" type="text/javascript" charset="utf-8"></script>
<?php
	function getConnection()
	{
		$username = "root";
		$password = "root";
		$server = "localhost";
		$port = "8889";
		$databasename = "php_demos";

		$connection = mysqli_connect(
							$server,  
							$username,  
							$password, 
							$databasename,
							$port
						);
						
		return $connection;		
	}

?>
</head>
<body>
<div class="table-wrapper">
<div class="wrapper-paging">
  <ul>
    <li><a class="paging-back">&lt;</a></li>
    <li><a class="paging-this"><strong>0</strong> of <span>x</span></a></li>
    <li><a class="paging-next">&gt;</a></li>
  </ul>
</div>
<div class="wrapper-panel">  
<table id="peaks">
	<thead>
		<tr>
			<th>ID</th>
			<th>Name</th>
			<th>Elevation</th>
			<th>Latitude</th>
			<th>Longitude</th>
			<th>Prominence</th>
			<th>Range</th>
			<th>Isolation</th>
			<th>State</th>
			<th>WA Bulger List</th>
		</tr>
	</thead>
	<tbody>
<?php

	$conn = getConnection();
	$query = "SELECT * FROM peaks_location";
	$stmt = mysqli_prepare($conn,$query);		

	mysqli_stmt_execute($stmt);
	mysqli_stmt_bind_result($stmt, $row->id, $row->name, $row->elevation, $row->latitude, $row->longitude, $row->prominence, $row->range, $row->isolation, $row->state, $row->wa_bulger_list);
	
	
	
	
	while (mysqli_stmt_fetch($stmt)) {
		printf ("<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>"
		, $row->id, $row->name, $row->elevation, $row->latitude, $row->longitude, $row->prominence, $row->range, $row->isolation, $row->state, $row->wa_bulger_list);
	}
	
	mysqli_stmt_free_result($stmt);
	mysqli_close($conn);

?>

<?php
	
?>
</tbody>
</table>
</div>
</div>
</body>
</html>
