$(document).ready(function(){
	$('#peaks tr').mouseover(function() {
		$(this).addClass('zebraHover');
	});
	$('#peaks tr').mouseout(function() {
		$(this).removeClass('zebraHover');
	});
	
	$('#peaks tr').click(function() {
		var lat = $(this).children('.latitude').text();
		var lon = $(this).children('.longitude').text();
		
		$(this).children('.name').append('<div class="gmap_marker"></div>');
		$('.gmap_marker').animate({'height':'+=250'}, 1000);
		$('.gmap_marker').gMap({ maptype: G_PHYSICAL_MAP,
								markers: [{latitude: lat, longitude: lon}],
								latitude: lat,
			                  	longitude: lon,
			                  	zoom: 12
			});

		$(this).unbind('click');
	});
});

